/*************************************************************************
New - BackandForthPid.ino
Rename to ReadButtons.ino
Remane to MilitaryMotor.ino
http://robotics.stackexchange.com/questions/167/what-are-good-strategies-for-tuning-pid-loops

Rename MilitaryMotor.ino 12 Jan 2015
26 Nov 2014n- ewh - NEW - limit switch version with PID

02 Sep 2014 - ewh - new, add LCD and buttons for Left and Right, Stop
                    and reset
02 Sep 2014 - ewh - added test run motor - next to add the LCD and buttons
                   Need to add separate power for the limit switch - 
03 Sep 2014 - ewh - Added code to run motor for LEFT and RIGHT and to
                    use variable for direction. Replace LEFT with FORWARD
                    and RIGHT with REVERSE
04 Sep 2014 - ewh - Basic code revisons, use function to print lines to
                    LCD display, delete un-needed code
05 Sep 2014 - ewh - Moved buttons code out of loop func, allows reading 
                    UP, DOWN, LEFT and RIGHT buttons on LCD
06 Sep 2014 - ewh - Revised code to read buttons when motor is running or
                    stopped
07 Sep 2014 - ewh - Trying to add feature to sense button pushes on LCD
		    Added revised code to run_motor to turn motor, and sense
		    buttons. Works with the limit switch and motor actually
		    running, but does not read the LCD buttons.  REVISED to
		    REQUIRE PRESSING RESET. Added read pot code to standard
		    run mode - works fine
08 Sep 2014 - ewh - General code clean up, delete uneeded comments, etc.
19 Sep 2014 - ewh - Removed lines, added stop_motor func to BUTTON_DOWN
20 Sep 2014 - ewh - Removed delay(255) statement from the change_direction
		    func this stoppped the motor over run.
10 Oct 2014 - ewh - revised speed map down to 41.6 min, and did a -2 for the
		    +speed dir
20 Oct 2014 - ewh - Revised code to use the VNH5019Dual motor shield
21 Oct 2014 - ewh - Added a user-defined pin map for the driver
22 Oct 2014 - ewh - Change limit switch pin to 3, so default setup for 5019 can
                    be used
22 Oct 2014 - ewh - Added current sense statement - need to check encoder use
27 Nov 2014 - ewh - Revised code - to simplify and add reverse and direct funcs
28 Nov 2014 - ewh - Revised code for the "stepper" mode and cleanup code
29 Nov 2014 - ewh - Modified Code for output to Processing 2
30 Dec 2014 - ewh - Delete the code here for timing loop - which is the 
                    sample time
31 Dec 2014 - ewh - Changed values of kp,ki, and kd - added freq chg for timer1 (test)
05 Jan 2015 - ewh - Revised Kp value from 0.4 to 0.42
05 Jan 2015 - ewh - Revise button access - remove menu, come up runable - add stop
06 Jan 2015 - ewh - Change name of motor direction (CW and CCW) from 
                    "controllerDirection" to "direction"
06 Jan 2015 - ewh - Can delete the rv.PID object - use myPID in MANUAL when 
                    the motor
09 Jan 2015 - ewh - Deleted the reverse_stop() function, added move motor or
                    step mode
11 Jan 2015 - ewh - Commented out NUMREADINGS and digital_smooth() function 
11 Jan 2015 - ewh - Take out serial printing code
12 Jan 2015 - ewh - Re-added serial print code
******************************************************************************/

//#include <DualVNH5019MotorShield.h>
#include <PID_v1.h>
#include <Wire.h>
#include <Adafruit_RGBLCDShield.h>
#include <Bounce2.h>

/*
DualVNH5019MotorShield::DualVNH5019MotorShield(unsigned char INA1, unsigned char INB1, unsigned char EN1DIAG1, unsigned char CS1, 
        unsigned char INA2, unsigned char INB2, unsigned char EN2DIAG2, unsigned char CS2)                                               
DualVNH5019MotorShield  md(INA1, INB1, EN1DIAG1, CS1, INA2, INB2, EN2DIAG2, CS2);   
*/
// DualVNH5019MotorShield  md(2, 4, 6, A0, 7, 8, 12, A1);  no need for this

// The shield uses the I2C SCL and SDA pins. On classic Arduinos
// this is Analog 4 and 5 so you can't use those for analogRead() anymore
// However, you can connect other I2C sensors to the I2C bus and share
// the I2C bus.
Adafruit_RGBLCDShield lcd = Adafruit_RGBLCDShield();

// These #defines for directions
#define InA1            2       // INA motor pin
#define InB1            4       // INB motor pin 
#define PWM1            9       // PWM motor pin			       		
#define encodPinA1      11      // encoder A pin
#define encodPinB1      13      // encoder B pin - set interrupt here
#define Vpin            A3      // battery monitoring analog pin
#define Apin            A0      // motor current monitoring analog pin

#define CURRENT_LIMIT   3000            // high current warning
#define LOW_BAT         8000 //10000    // low bat warning
#define LOOPTIME        100             // PID loop time - deleted 30 Dec
//#define NUMREADINGS     10              // samples for Amp average
#define CW   0  // change to clockwise
#define CCW  1  // change to counter clockwise

//int readings[NUMREADINGS];
unsigned long lastMilli = 0;            // loop timing 
unsigned long lastMilliPrint = 0;       // loop timing

int speed_req = 40;                     // speed (Set Point)  
int speed_act = 0;                      // speed (actual value)
int PWM_val = 0;                        // (25% = 64; 50% = 127; 75% = 191; 100% = 255)
int voltage = 0;                        // in mV
int current = 0;                        // in mA

volatile long encoderValue = 0;
volatile long lastEncoderValue = 0;
volatile long count = 0;              // rev counter

double Input, Output, Setpoint; 
double input, output, setpoint; 
//**double kp=0.3,ki=1,kd=0; seem to be best values
//double kp=0.3,ki=1,kd=0; //2,.5,2 .3 1 0
double kp=0.42,ki=0.9,kd=0.11; //2,.5,2 .3 1 0 // for pololu motor

unsigned long serialTime;

PID myPID(&Input, &Output, &Setpoint,kp,ki,kd, DIRECT);

int limitButtonPin3State = 0;  
int LastButtonPin3State = 0; 
int val;
int speed = 0;
int mspeed;
int state;
 
boolean rotate1;
boolean useMenu = true; 
boolean bLeft = false;
boolean LimitButtonState;
boolean run = false;        // motor moves

long rev = 8384;
long countInit;
long tickNumber = 0;

uint8_t buttons;
uint8_t direction;
uint8_t motorRUN;
 
const uint8_t limitButtonPin3 = 3; // cannot use pin 2 for vnh5019 use differnt pin;
const uint8_t analogPin = A2; // detects the mapped pot value, set speed of motor
const unsigned long BAUD_RATE = 115200;

Bounce debouncer = Bounce(); 
 
void setup()
{   
   Serial.begin(BAUD_RATE);
   //Serial.println(F("New VNH5019 Driver Test"));      
   count = 0;
   countInit = 0;
   
   cli();  // disable interrupts 
    // CANNOT USE ARDUINO PIN 8,9,10,12,A0,A1 for non-controller/Arduino signals
    // bit-pin map 0=8,1=9,2=10,3=11,4=12,5=13 "B" register (digital pin 8 to 13)
    // cannot use bits 6 and 7 on reg B
      DDRD  |= (0 << 3);  //  Enable pin 3 as INPUT for limit switch
      PORTD |= (0 << 3);  //  Set Arduino pin 3 low for limit switch
      DDRD  |= (1 << 2);  // eqiv to pinMode InA1
      DDRD  |= (1 << 4);  // eqiv to pinMode InB1
      DDRB  |= (1 << 1);  // eqiv to pinMode PWM1    
      DDRB  |= (0 << 3);  //  Enable pin 11 as INPUT for encodPinA1 set low (was 2)
      PORTB |= (1 << 3);  //  Set Arduino pin 11 HIGH for pull up (encodPinA1) (was 2)
      DDRB  |= (0 << 5);  //  Enable pin 13 as INPUT for limit switch - set low (was 3)
      PORTB |= (1 << 5);  //  Set Arduino pin 13 HIGH for pull up and encodPinB1 (was 3)
      DDRD  |= (0 << 2);  //  Set direction for Arduino pin 2 as input
      PORTD |= (0 << 2);  //  Set digial pin 2 HIGH CW
      DDRD  |= (0 << 4);  //  Set direction for Arduino pin 4 as input
      PORTD |= (1 << 4);  //  Set digial pin 4 LOW  CW      
      PCICR  |= (1 << PCIE0);   // enable group interrupts on PORTB PCINT[7:0]
      PCMSK0 |= (1 << PCINT5); // enable interrupt pin 13-bit 5
      //*************** FREQ Change for test
      TCCR1B = (TCCR1B & 0XF8) | 2; //3906 HZ=2, 3=488HZ
    sei();  // enable interrupts  bit 3=11 bit 2 = 10      
      //for(int i=0; i<NUMREADINGS; i++) readings[i] = 0;  // initialize readings to 0    
      analogWrite(PWM1, PWM_val);  
      Input = speed_act;      
      Setpoint = 20; //speed_req;      
     //turn the PID on
      myPID.SetMode(AUTOMATIC); 
     // myPID.SetMode(MANUAL); 
      direction = CCW; 
  
   lcd.begin(16, 2);   
   lcd.print(F("Press L or R Btn"));
   lcd.setCursor(0,1);
   lcd.print(F("to Run Motor"));   
    
   debouncer.attach(limitButtonPin3);     
   debouncer.interval(5);
    
   LimitButtonState = false;
   LastButtonPin3State = 0;
   rotate1 = true;
   motorRUN = 1; 
   useMenu = false;
   run = false;
 }

//ISR for Pin 8 was 0 and 1, change to 3 and 2 for pins 13 and 11
ISR (PCINT0_vect)    // handle pin change interrupt for D8-D13;  triggered by arduino pin 13
{	
  if(bitRead(PINB,5)== bitRead(PINB,3)) {  //(PINB, x) is the syntax to read the input state from PORTB, bit x 
      encoderValue++;          
  } else {
      encoderValue--;      
  } 
}

void counter_clockwise()
{
  digitalWrite(InA1, LOW);  // CCW
  digitalWrite(InB1, HIGH); // CCW	
}

void clockwise()
{
   digitalWrite(InA1, HIGH);  // CW
   digitalWrite(InB1, LOW);   // CW
}

void OpenMenu()
{
   setLCD("Motor/PID INIT", "Press L or R", 0, 2); // 2 is two lines, 0 is top 1 is top or bottom line       
   rotate1 = true;            
   myPID.SetMode(AUTOMATIC);    
 }
 
 void clearLCD(int charx, int row, boolean bClear)
 {
    if (bClear) { lcd.clear(); }
    lcd.setCursor(charx,row);
 }
 
 void setLCD(char *line1, char *line2, int start, int row)  
 {   // 2 is two lines, 0 is top 1 is top or bottom line  
         switch (row) {
          case 0:
             lcd.setCursor(start,0);
             lcd.print(line1);
           break;          
          case 1:
             lcd.setCursor(start,1);
  	       lcd.print(line1);
           break;         
          case 2:
             lcd.setCursor(start,0);
             lcd.print(line1);
             lcd.setCursor(start,1);
             lcd.print(line2);
           break;
          default:
            Serial.println("break");
       }      
       line1 = "";
       line2 = "";   
} // end setLCD
  
// read pot values and map to "speed or rpm"
int readPot()
{
  val = analogRead(analogPin);
  mspeed = map(val, 0, 1023, 1, 105);  
  return mspeed;
}

void change_direction()
{ 
  motorBrake(0); // use brake low to gnd 
  
  if (Setpoint > 20)  {  //was setpoint not Setpoint
      Setpoint = 13;
   } else {
      Setpoint = 13;
   }    
  
  if (direction == CCW) {
         clockwise();  // try delete, see if sign on pid changes dir?
         Input = speed_act;         
       }else{
         counter_clockwise();
         Input = -speed_act;
      }      
  
   myPID.Compute();
   analogWrite(PWM1, Output);   //was output
}

// deleted the reverse_stop() function

void motorBrake(int level)
{  
  if (level == 1) {
    digitalWrite(InA1, HIGH);
    digitalWrite(InB1, HIGH);
  } else {
    digitalWrite(InA1, LOW);
    digitalWrite(InB1, LOW);
  }
}

void stop_motor()
{
  delay(45);  
  motorBrake(1);
  speed_req = 0; 
  LimitButtonState = false; 
  rotate1 = false;	  
  motorRUN = 0;
  count = 0;   
}

void getMotorData()     // calculate speed, volts and Amps
   {                                         
     static long countAnt = 0;  // last count // 64 pulses X 131 gear ratio = 8384, try 32 > 4192 
     speed_act = ((encoderValue - countAnt)*(60*(1000/LOOPTIME)))/(16*19.2);  //16 not required
     if (direction == CCW) {
       Input = -speed_act;       
     }else{
       Input = speed_act;
     }
     countAnt = encoderValue;      
   } 

void run_motor(uint8_t DIR)
 {     
    do {
      
        limitButtonPin3State = digitalRead(limitButtonPin3);
       
    
        Setpoint = readPot();  
        
        if (limitButtonPin3State != LastButtonPin3State) {   
            count++;           
            LimitButtonState = true;
            LastButtonPin3State = limitButtonPin3State;
        }
         
        if (DIR == CW) { 
            direction = CW;
            clockwise();   
        
	     if((millis()-lastMilli) >= LOOPTIME) {  // enter timed loop
	       lastMilli = millis(); 
	       getMotorData();            // calculate speed, volts and Amps	
	     }	      
	       motorRUN = 1;  
         }
	  	                     
	   if (DIR == CCW) {
	      direction = CCW;
	      counter_clockwise();  
	      
	       if((millis()-lastMilli) >= LOOPTIME) {    // enter timed loop
	      	lastMilli = millis(); 	       		
	      	getMotorData();        // calculate speed, volts and Amps       
	     }		                  
        }
        
        //*** format- moveMotor(int PWM_val, long tick)           
       
          myPID.Compute();
	  analogWrite(PWM1, Output);  // send PWM to motor, arduino  pin 9  
	
         if(millis()>serialTime) {
	   SerialReceive();
	   SerialSend();
	   serialTime+=500; 
	 }	
	          
        if (LastButtonPin3State == 1) {
            setLCD("MOTOR STOPPED", "Press L or R", 0, 2);            
            myPID.SetMode(MANUAL);           
	    change_direction();	 
	} else {	  
	      //***Serial.println("Motor Running!");	     
        } 
         
    } while (!LimitButtonState);
} // end run motor 

void read_buttons()
{   
   limitButtonPin3State = digitalRead(limitButtonPin3); 
   LastButtonPin3State = limitButtonPin3State;   
   
   buttons = lcd.readButtons();
     
   if (buttons ) {          
       lcd.clear();             
       
      if (buttons & BUTTON_UP) {                  
         setLCD("DC Motor INIT", "Press L or R", 0, 2); 
         // setLCD args: 2 is two lines, 0 is top 1 is top or bottom line       
         rotate1 = true;              
      }
                  
      if (buttons & BUTTON_DOWN ) {       
   	    setLCD("RESET MOTOR!", "Motor Ready", 0, 2);
   	    rotate1 = true;
   	    stop_motor();    	   
   	
   	    if (!rotate1) {
   	      setLCD("Press SELECT or", "UP to Run Motor", 0, 2);   	      
   	      LimitButtonState = false;
   	      rotate1 = true;
   	    }
        }
        
   // this area needs to be fixed, if reset all, all ok, but if hit limit,
   // and then press L or R (depending on where trolley is), the change_dir function
   // does not work - motor stops against the limit switch
                  
       if (buttons & BUTTON_LEFT ) { 
           if (rotate1) {
             setLCD("MOTOR RUNNING", "Moving LEFT", 0, 2);
             run_motor(CW);              
             motorRUN = 1;             
           } else {
             myPID.SetMode(MANUAL);
             Input = Setpoint;
             setLCD("Pressed L", "To Run Motor", 0, 2);
             rotate1 = true;
             run_motor(CW);
           }      
        }
     	      
     	if (buttons & BUTTON_RIGHT  ) {
     	     if (rotate1) {
     	        setLCD("MOTOR RUNNING", "Moving RIGHT", 0, 2);      	        
     	        run_motor(CCW);     	        
     	        motorRUN = 1;     	  
     	     } else {
     	        myPID.SetMode(MANUAL);   //both l and r the input spikes to 0 when in the non-reset mode
     	        Input = Setpoint;
     	        setLCD("Pressed R", "To Run Motor", 0, 2);
     	        rotate1 = true;
     	        run_motor(CCW);
     	     }                              
         }	     
                         
          if (buttons & BUTTON_SELECT ) {		      
     	     // do something here later     	    
           }   	 
       }
   }   
 
void loop()
{  
  limitButtonPin3State = digitalRead(limitButtonPin3);   
  
      while (limitButtonPin3State == 0)//(!LimitButtonState)
      {        
         limitButtonPin3State = digitalRead(limitButtonPin3);             
        
         if(limitButtonPin3State != LastButtonPin3State) {            
           stop_motor(); //check this in light of state checks, etc          
           buttons = lcd.readButtons();       
         }        
         read_buttons();
         //LastButtonPin3State = limitButtonPin3State;
      }   
}  // end loop

/********************************************
 * Serial Communication functions / helpers
   for use with the Processing 2 application
 ********************************************/

union {                // This Data structure lets
  byte asBytes[24];    // us take the byte array
  float asFloat[6];    // sent from processing and
}                      // easily convert it to a
foo;                   // float array

// getting float values from processing into the arduino
// was no small task.  the way this program does it is
// as follows:
//  * a float takes up 4 bytes.  in processing, convert
//    the array of floats we want to send, into an array
//    of bytes.
//  * send the bytes to the arduino
//  * use a data structure known as a union to convert
//    the array of bytes back into an array of floats

//  the bytes coming from the arduino follow the following
//  format:
//  0: 0=Manual, 1=Auto, else = ? error ?
//  1: 0=Direct, 1=Reverse, else = ? error ?
//  2-5: float setpoint
//  6-9: float input
//  10-13: float output  
//  14-17: float P_Param
//  18-21: float I_Param
//  22-245: float D_Param
void SerialReceive()
{
  // read the bytes sent from Processing
  int index=0;
  byte Auto_Man = -1;
  byte Direct_Reverse = -1;
  while(Serial.available()&&index<26)
  {
    if(index==0) Auto_Man = Serial.read();
    else if(index==1) Direct_Reverse = Serial.read();
    else foo.asBytes[index-2] = Serial.read();
    index++;
  } 
  
  // if the information we got was in the correct format, 
  // read it into the system
  if(index==26  && (Auto_Man==0 || Auto_Man==1)&& (Direct_Reverse==0 || Direct_Reverse==1))
  {
    Setpoint=double(foo.asFloat[0]);
    //Input=double(foo.asFloat[1]);       // * the user has the ability to send the 
                                          //   value of "Input"  in most cases (as 
                                          //   in this one) this is not needed.
    if(Auto_Man==0)                       // * only change the output if we are in 
    {                                     //   manual mode.  otherwise we'll get an
      Output=double(foo.asFloat[2]);      //   output blip, then the controller will 
    }                                     //   overwrite.
    
    double p, i, d;                       // * read in and set the controller tunings
    p = double(foo.asFloat[3]);           //
    i = double(foo.asFloat[4]);           //
    d = double(foo.asFloat[5]);           //
    myPID.SetTunings(p, i, d);            //
    
    if(Auto_Man==0) myPID.SetMode(MANUAL);// * set the controller mode
    else myPID.SetMode(AUTOMATIC);             //
    
    if(Direct_Reverse==0) myPID.SetControllerDirection(DIRECT);// * set the controller Direction
    else myPID.SetControllerDirection(REVERSE);          //
  }
  Serial.flush();                         // * clear any random data from the serial buffer
}

// unlike our tiny microprocessor, the processing ap
// has no problem converting strings into floats, so
// we can just send strings.  much easier than getting
// floats from processing to here no?
void SerialSend()
{
  Serial.print("PID ");
    Serial.print(Setpoint);   
    Serial.print(" ");
    Serial.print(Input);   
    Serial.print(" ");
    Serial.print(Output);   
    Serial.print(" ");
    Serial.print(myPID.GetKp());   
    Serial.print(" ");
    Serial.print(myPID.GetKi());   
    Serial.print(" ");
    Serial.print(myPID.GetKd());   
    Serial.print(" ");
    if(myPID.GetMode()==AUTOMATIC) Serial.print("Automatic");
    else Serial.print("Manual");  
    Serial.print(" ");
    if(myPID.GetDirection()==DIRECT) Serial.println("Direct");
  else Serial.println("Reverse");
}


